import { ActionTypes, ExtractResult, SagaBoilerplate, State } from "./concoctBoilerplate";
export declare type EntityRepository<ID, ListParams extends any[], ListResponse, GetResponse, CreateParams extends any[], CreateResponse, UpdateParams extends any[], UpdateResponse, DeleteResponse> = {
    readonly list: (...params: ListParams) => ListResponse;
    readonly get: (id: ID) => GetResponse;
    readonly create: (...params: CreateParams) => CreateResponse;
    readonly update: (...params: UpdateParams) => UpdateResponse;
    readonly delete: (id: ID) => DeleteResponse;
};
export declare const actionTypes: (entityName: string, entityNamePlural: string) => ActionTypes<EntityRepository<any, any, any, any, any, any, any, any, any>>;
export declare type CrudState<ER extends EntityRepository<any, any, any, any, any, any, any, any, any>, ErrorType extends unknown = Error> = {
    readonly list: State<ErrorType, ExtractResult<ER["list"]>>;
    readonly current: State<ErrorType, ExtractResult<ER["get"]>>;
    readonly created: State<ErrorType, ExtractResult<ER["create"]>>;
    readonly updated: State<ErrorType, ExtractResult<ER["update"]>>;
    readonly deleted: State<ErrorType, ExtractResult<ER["delete"]>>;
};
export declare const concoctCrud: <EntityNamePlural extends string, ID, ListParams extends any[], ListResponse, GetResponse, CreateParams extends any[], CreateResponse, UpdateParams extends any[], UpdateResponse, DeleteResponse>(entityName: string, entityNamePlural: EntityNamePlural, repo: EntityRepository<ID, ListParams, ListResponse, GetResponse, CreateParams, CreateResponse, UpdateParams, UpdateResponse, DeleteResponse>) => SagaBoilerplate<EntityRepository<ID, ListParams, ListResponse, GetResponse, CreateParams, CreateResponse, UpdateParams, UpdateResponse, DeleteResponse>, ActionTypes<EntityRepository<ID, ListParams, ListResponse, GetResponse, CreateParams, CreateResponse, UpdateParams, UpdateResponse, DeleteResponse>>, { readonly [k in EntityNamePlural]: CrudState<EntityRepository<ID, ListParams, ListResponse, GetResponse, CreateParams, CreateResponse, UpdateParams, UpdateResponse, DeleteResponse>, Error>; }, Error>;
