"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const redux_1 = require("redux");
const concoctBoilerplate_1 = require("./concoctBoilerplate");
exports.actionTypes = (entityName, entityNamePlural) => {
    const entityNameUpper = entityName.toUpperCase();
    const entityNamePluralUpper = entityNamePlural.toUpperCase();
    return {
        list: [
            `LIST_${entityNamePluralUpper}`,
            `LIST_${entityNamePluralUpper}_SUCCESS`,
            `LIST_${entityNamePluralUpper}_FAILURE`,
            "list"
        ],
        get: [
            `GET_${entityNameUpper}`,
            `GET_${entityNameUpper}_SUCCESS`,
            `GET_${entityNameUpper}_FAILURE`,
            "current"
        ],
        create: [
            `CREATE_${entityNameUpper}`,
            `CREATE_${entityNameUpper}_SUCCESS`,
            `CREATE_${entityNameUpper}_FAILURE`,
            "created"
        ],
        update: [
            `UPDATE_${entityNameUpper}`,
            `UPDATE_${entityNameUpper}_SUCCESS`,
            `UPDATE_${entityNameUpper}_FAILURE`,
            "updated"
        ],
        delete: [
            `DELETE_${entityNameUpper}`,
            `DELETE_${entityNameUpper}_SUCCESS`,
            `DELETE_${entityNameUpper}_FAILURE`,
            "deleted"
        ]
    };
};
exports.concoctCrud = (entityName, entityNamePlural, repo) => {
    const { actions, rootReducer, rootSaga } = concoctBoilerplate_1.concoctBoilerplate(repo, exports.actionTypes(entityName, entityNamePlural));
    // TODO remove these casts
    const entityReducer = {
        [entityNamePlural]: redux_1.combineReducers(rootReducer)
    };
    return { actions, rootReducer: entityReducer, rootSaga };
};
