"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const effects_1 = require("redux-saga/effects");
const _1 = require(".");
// tslint:disable: no-expression-statement
it("concocts boilerplate", async () => {
    const userApi = {
        get: (id) => {
            return Promise.resolve({
                id,
                username: "username"
            });
        },
        syncGet: (id) => {
            return {
                id,
                username: "username"
            };
        }
        // TODO support subsets
        // delete: (id: string): Promise<void> => {
        //   // tslint:disable-next-line: no-reject
        //   return Promise.reject("Not implemented")
        // }
    };
    const actionTypes = {
        get: ["GET_USER", "GET_USER_SUCCESS", "GET_USER_FAILURE"],
        syncGet: ["SYNC_GET_USER", "SYNC_GET_USER_SUCCESS", "SYNC_GET_USER_FAILURE"]
    };
    const { get: [getUser, , , getUserReducer, getUserSaga], syncGet: [getSyncUser, , , getSyncUserReducer, getSyncUserSaga] } = _1.concoctBoilerplate(userApi, actionTypes, {});
    const action = getUser("42");
    const syncAction = getSyncUser("42");
    // TODO move this boilerplate into concoctBoilerplate
    const allReducers = () => ({
        user: getUserReducer,
        syncUser: getSyncUserReducer
    });
    function* rootSaga() {
        // TODO move this boilerplate into concoctBoilerplate
        yield effects_1.all([
            effects_1.takeLatest("GET_USER", getUserSaga),
            effects_1.takeLatest("SYNC_GET_USER", getSyncUserSaga)
        ]);
    }
    allReducers();
    rootSaga();
    expect(action).toEqual({
        type: "GET_USER",
        payload: {
            params: ["42"]
        }
    });
    expect(syncAction).toEqual({
        type: "SYNC_GET_USER",
        payload: {
            params: ["42"]
        }
    });
});
